function angles=Inverse_kinematics(T,lastTheta)

global a1 a2 a3 d1 d4 d6

o=T(1:3,4);
R=T(1:3,1:3);

oc=o-d6*R*[0;0;1];

%handling of the shoulder singularity.
if round(oc(1)*10^12)*10^(-12)~=0 || round(oc(2)*10^12)*10^(-12)~=0
    th1=atan2(oc(1),oc(2));
    th1s=[th1,th1-pi];
else
    disp('singular position detected in the shoulder!')
    th1s=lastTheta(1);
end
theta123=[];


for th1=th1s
    
    %calculate theta3:
    ocp=[ oc(2)*cos(th1) + oc(1)*sin(th1);
                             oc(3)];
    o2p=[a1;d1];
    r=ocp(1)-o2p(1);
    s=ocp(2)-o2p(2);
    dm=r^2+s^2;                         %dm=a2^2 - 2*sin(theta3)*a2*a3 + 2*cos(theta3)*a2*d4 + a3^2 + d4^2
    dm=(dm-a2^2-a3^2-d4^2)/(2*a2);       %dm=d4*cos(theta3) - a3*sin(theta3)
    
    arg=a3^2 + d4^2 - dm^2;
    
    if arg<0
        continue
    end
    
    th31=-2*atan((a3 - (arg)^(1/2))/(d4 + dm));
    th32=-2*atan((a3 + (arg)^(1/2))/(d4 + dm));
        
    %calculate theta2
    a3m=sqrt(a3^2+d4^2);
    theta3m=-th31-atan(a3/d4);

    th21=atan2(r,s)-atan2(a2+a3m*cos(theta3m),a3m*sin(theta3m));
    theta3m=-th32-atan(a3/d4);

    th22=atan2(r,s)-atan2(a2+a3m*cos(theta3m),a3m*sin(theta3m));

    theta123(1:3,size(theta123,2)+1)=[th1;th21;th31];
    theta123(1:3,size(theta123,2)+1)=[th1;th22;th32];
    
end


angles=zeros(6,size(theta123,2)*2);
for i=1:size(theta123,2)
        
    th1=theta123(1,i);
    th2=theta123(2,i);
    th3=theta123(3,i);

    R03_T =[
      -sin(th2 + th3)*sin(th1), -sin(th2 + th3)*cos(th1), -cos(th2 + th3)
                     cos(th1),                -sin(th1),               0
     -cos(th2 + th3)*sin(th1), -cos(th2 + th3)*cos(th1),  sin(th2 + th3)];
    R36=R03_T*R;
    
    th51=acos(-R36(3,3));
    th52=-th51;
    
    if round(th51*10^10)*10^-10~=0
        th41=atan2(R36(2,3),R36(1,3));
        th42=th41+pi;
        th61=atan2(-R36(3,2),-R36(3,1));
        th62=th61+pi;
        angles(:,((i-1)*2+1):((i)*2))=[[theta123(:,i);th41;th51;th61] [theta123(:,i);th42;th52;th62]];
    else
        disp('singular configuration in the spherical joint')
        th61=lastTheta(4);
        th41=atan2(-R36(1,2),-R36(1,1));                
        angles(:,((i-1)*2+1):((i)*2))=[[theta123(:,i);th41;th51;th61] [theta123(:,i);th41+pi;th52;th61+pi]];
    end
        
    
end

angles=mod(angles,2*pi);

%return
%return the value closest to the last angles

if isempty(lastTheta)~=1
    errors=(angles-(lastTheta)*ones(1,size(angles',1))).^2;
    [val ind]=min(sum(errors,1));
    angles=angles(:,ind);
end






