function state_dot=Robot3(t,state)


global Kp Kd radref S w1 w2 w3 w4 w5 w6 turn_on_speed Kd6 Kp6 global_time 
global a1 a2 a3 d1 d4 d6 pc r_sphere sat Ut START

if turn_on_speed==0
     t=global_time;
end

q=state(1:6);
qd=state(7:12);

qr=[
w1*t;    
radref*sin(w2*t);    
radref*sin(w3*t);    
radref*cos(w4*t);    
radref*sin(w5*t);    
radref*cos(w6*t);    
];
qr=qr+START;
qrd=turn_on_speed*[
w1;    
-w2*radref*cos(w2*t);    
-w3*radref*cos(w3*t);    
-w4*radref*sin(w4*t);    
w5*radref*cos(w5*t);    
-w6*radref*sin(w6*t);    
];
qrdd=turn_on_speed*[
0;    
-w2^2*radref*sin(w2*t);    
-w3^2*radref*sin(w3*t);    
-w4^2*radref*cos(w4*t);    
-w5^2*radref*sin(w5*t);    
-w6^2*radref*cos(w6*t);    
];

% R=Rq'*Rr;
% 
% %orientation error
% oe=1/2*(cross(R(:,1),Rr(:,1))+cross(R(:,2),Rr(:,2))+cross(R(:,3),Rr(:,3)));
% L=-1/2*(S(Rr(:,1))*S(Rq(:,1))+S(Rr(:,2))*S(Rq(:,2))+S(Rr(:,3))*S(Rq(:,3)));
% 
% %orientation velocity
% oed=L'*w_ref-L*w;
% 
% Ja=[eye(3) zeros(3);zeros(3) L]*J;
%find the orientaiton error


T=forward_kinematics(q);
Rq=T(1:3,1:3);
x=T(1:3,4);

Tr=forward_kinematics(qr);
Rr=Tr(1:3,1:3);
x_ref=Tr(1:3,4);

J=jacobian_end_effector(q);
Jr=jacobian_end_effector(qr);

temp=J*qd;
v=temp(1:3);
w=temp(4:6);

temp=Jr*qrd;
v_ref=temp(1:3);
w_ref=temp(4:6);

Jrd=jacobian_dt(qr,qrd);
Jd=jacobian_dt(q,qd);

temp=Jr*qrdd+Jrd*qrd;
a_ref=temp(1:3);
wd_ref=temp(4:6);

Rdiff=Rq'*Rr;

psi = atan2(Rdiff(3,2),Rdiff(3,3));
phi = atan2(Rdiff(2,1),Rdiff(1,1));
theta = atan2(-Rdiff(3,1),cos(phi)*Rdiff(1,1) + sin(phi)*Rdiff(2,1));

B=[0 -sin(phi) cos(phi)*cos(theta);
   0  cos(phi) sin(phi)*cos(theta);
   1          0        -sin(theta)];
 
Bi=[
 cos(phi)*tan(theta), sin(phi)*tan(theta), 1
         -sin(phi),              cos(phi), 0
 cos(phi)/cos(theta), sin(phi)/cos(theta), 0];

   
dBd_phi=[
 0, -cos(phi), -cos(theta)*sin(phi)
 0, -sin(phi),  cos(phi)*cos(theta)
 0,         0,                    0];
 
dBd_theta=[ 
 0, 0, -cos(phi)*sin(theta)
 0, 0, -sin(phi)*sin(theta)
 0, 0,          -cos(theta)];   
    
   
w_diff=w_ref-w;
rpy_d=Bi*Rq'*w_diff;

dB_dt=dBd_phi*rpy_d(1)+dBd_theta*rpy_d(2);


%this one sees to work
%u2_o=[wd_ref+dB_dt*rpy_d+B*(Kd*rpy_d+Kp*[phi;theta;psi])];

%

u2_o=[wd_ref-(S(w)*Rq*B+Rq*dB_dt)*rpy_d + Rq*B*(0.1*Kd*rpy_d+0.1*Kp*[phi;theta;psi])];
%u2_o=[wd_ref+Kd*w_diff+Rq*B*(Kp*[phi;theta;psi])];

    
Ji=J'/(J*J'+0.001*eye(6));
% end

u_repulsive=zeros(3,1);
rho_0=0.5;

%first wall
if abs(x(2)+2)<rho_0 && v(2)<0
     u_repulsive=u_repulsive+[0;1;0]*1/((x(2)+2))^2*(1/abs(((x(2)+2)))-1/rho_0);
end

%second wall
if abs(x(2)-2)<rho_0 && v(2)>0
     u_repulsive=u_repulsive+[0;-1;0]*1/((x(2)-2))^2*(1/abs(((x(2)-2)))-1/rho_0);
end

%third  wall
if abs(x(1)+2)<rho_0 && v(1)<0    
     u_repulsive=u_repulsive+[1;0;0]*1/((x(1)+2))^2*(1/abs(((x(1)+2)))-1/rho_0);
end

%fourth wall
if abs(x(1)-2)<rho_0 && v(1)>0
     u_repulsive=u_repulsive+[-1;0;0]*1/((x(1)-2))^2*(1/abs(((x(1)-2)))-1/rho_0);
end

%floor end effector force
if abs(x(3))<rho_0 && v(3)<0
     u_repulsive=u_repulsive+[0;0;1]*1/((x(3)))^2*(1/abs(((x(3))))-1/rho_0);
end

F_ee=u_repulsive;

%TEST THE MOBILITY TENSOR
u_repulsive1=zeros(3,1);
rho_0=0.5;

%first wall
if abs(x(2)+2)<rho_0 %&& v(2)<0
     u_repulsive1=u_repulsive+[0;1;0]*1/((x(2)+2))^2*(1/abs(((x(2)+2)))-1/rho_0);
end

%second wall
if abs(x(2)-2)<rho_0 %&& v(2)>0
     u_repulsive1=u_repulsive+[0;-1;0]*1/((x(2)-2))^2*(1/abs(((x(2)-2)))-1/rho_0);
end

%third  wall
if abs(x(1)+2)<rho_0 %&& v(1)<0    
     u_repulsive1=u_repulsive+[1;0;0]*1/((x(1)+2))^2*(1/abs(((x(1)+2)))-1/rho_0);
end

%fourth wall
if abs(x(1)-2)<rho_0 %&& v(1)>0
     u_repulsive1=u_repulsive+[-1;0;0]*1/((x(1)-2))^2*(1/abs(((x(1)-2)))-1/rho_0);
end

%floor end effector force
if abs(x(3))<rho_0 %&& v(3)<0
     u_repulsive1=u_repulsive+[0;0;1]*1/((x(3)))^2*(1/abs(((x(3))))-1/rho_0);
end

%M=massmatrix_good(q);
%u_repulsive=J*inv(M)*J'*[u_repulsive1;0;0;0];

%END TEST THE MOBILITY TENSOR




%u2_pos=-Kp*(x-x_ref)-Kd*(v-v_ref)+a_ref+u_repulsive;
%find shorest distence to sphere 

q1=q(1);
q2=q(2);
q3=q(3);
q4=q(4);
q5=q(5);
q6=q(6);

o0 =[
    0
    0
    0];


o1 =[
 a1*sin(q1)
 a1*cos(q1)
         d1];
 
 
o2 =[
 sin(q1)*(a1 + a2*cos(q2))
 cos(q1)*(a1 + a2*cos(q2))
               d1 - a2*sin(q2)];
 
 
o3 =[
 sin(q1)*(a1 + a2*cos(q2) - a3*sin(q2+q3))
 cos(q1)*(a1 + a2*cos(q2) - a3*sin(q2+q3))
               d1 - a3*cos(q2+q3) - a2*sin(q2)];
 
 
o4 =[
 sin(q1)*(a1 + a2*cos(q2) + d4*cos(q2+q3) - a3*sin(q2+q3))
 cos(q1)*(a1 + a2*cos(q2) + d4*cos(q2+q3) - a3*sin(q2+q3))
               d1 - a3*cos(q2+q3) - a2*sin(q2) - d4*sin(q2+q3)];
 
 
o5 =[
 sin(q1)*(a1 + a2*cos(q2) + d4*cos(q2+q3) - a3*sin(q2+q3))
 cos(q1)*(a1 + a2*cos(q2) + d4*cos(q2+q3) - a3*sin(q2+q3))
               d1 - a3*cos(q2+q3) - a2*sin(q2) - d4*sin(q2+q3)];
 
 
o6 =[
 sin(q1).*(a1 + a2*cos(q2) + d4*cos(q2+q3) - a3*sin(q2+q3)) + d6*(sin(q5).*(cos(q1)*sin(q4) - cos(q4)*sin(q2+q3)*sin(q1)) + cos(q2+q3)*cos(q5)*sin(q1))
 cos(q1).*(a1 + a2*cos(q2) + d4*cos(q2+q3) - a3*sin(q2+q3)) - d6*(sin(q5).*(sin(q1)*sin(q4) + cos(q1)*cos(q4)*sin(q2+q3)) - cos(q2+q3)*cos(q1)*cos(q5))
                                                                   d1 - d6*(cos(q5)*sin(q2+q3) + cos(q2+q3)*cos(q4)*sin(q5)) - a3*cos(q2+q3) - a2*sin(q2) - d4*sin(q2+q3)];
            


%calculate and show the shortest distance from the robot to the sphere
%obstacle

%these are the points on the robot which are closest to the sphere 
p1=o0+sat((o0-o1)'*(o0-pc)/norm(o0-o1)^2)*(o1-o0);
p2=o1+sat((o1-o2)'*(o1-pc)/norm(o1-o2)^2)*(o2-o1);
p3=o3+sat((o3-o4)'*(o3-pc)/norm(o3-o4)^2)*(o4-o3);
p4=o5+sat((o5-o6)'*(o5-pc)/norm(o5-o6)^2)*(o6-o5);


%calculate the jacobian_v for each point


z0 =[
     0
     0
    -1];

z1 =[
 -cos(q1)
  sin(q1)
        0];
 
z2 =[
 -cos(q1)
  sin(q1)
        0];
 
z3 =[
 -cos(q2 + q3)*sin(q1)
 -cos(q2 + q3)*cos(q1)
          sin(q2 + q3)];
 
z4 =[
 - cos(q1)*cos(q4) - sin(q2 + q3)*sin(q1)*sin(q4)
   cos(q4)*sin(q1) - sin(q2 + q3)*cos(q1)*sin(q4)
                            -cos(q2 + q3)*sin(q4)];
%  
% z5 =[
%  - sin(q5)*(cos(q1)*sin(q4) - sin(q2 + q3)*cos(q4)*sin(q1)) - cos(q2 + q3)*cos(q5)*sin(q1)
%    sin(q5)*(sin(q1)*sin(q4) + sin(q2 + q3)*cos(q1)*cos(q4)) - cos(q2 + q3)*cos(q1)*cos(q5)
%                                        sin(q2 + q3)*cos(q5) + cos(q2 + q3)*cos(q4)*sin(q5)];
%  
% z6 =[
%  sin(q5)*(cos(q1)*sin(q4) - sin(q2 + q3)*cos(q4)*sin(q1)) + cos(q2 + q3)*cos(q5)*sin(q1)
%  cos(q2 + q3)*cos(q1)*cos(q5) - sin(q5)*(sin(q1)*sin(q4) + sin(q2 + q3)*cos(q1)*cos(q4))
%                                    - sin(q2 + q3)*cos(q5) - cos(q2 + q3)*cos(q4)*sin(q5)];


%the velocity jacobian for the different contact points                                
J_p1=[cross(z0,p1-o0),zeros(3,5)];
J_p2=[cross(z0,p2-o0),cross(z1,p2-o1),zeros(3,4)];
J_p3=[cross(z0,p3-o0),cross(z1,p3-o1),cross(z2,p3-o2),zeros(3,3)];
J_p4=[cross(z0,p4-o0),cross(z1,p4-o1),cross(z2,p4-o2),zeros(3,3)];
                           

%the obstacle repulsion force for the sphere

F_1t=zeros(3,1);
F_2t=zeros(3,1);
F_3t=zeros(3,1);
F_4t=zeros(3,1);

%the distances from the links to the obstacle
d_1=norm(pc-p1)-r_sphere;
d_2=norm(pc-p2)-r_sphere;
d_3=norm(pc-p3)-r_sphere;
d_4=norm(pc-p4)-r_sphere;

d_1_dot=-1/norm(pc-p1)*(pc-p1)'*J_p1*qd;
d_2_dot=-1/norm(pc-p2)*(pc-p2)'*J_p2*qd;
d_3_dot=-1/norm(pc-p3)*(pc-p3)'*J_p3*qd;
d_4_dot=-1/norm(pc-p4)*(pc-p4)'*J_p4*qd;


nu=1;

%calculate the repelling forces from the sphere:

turn_on_Jacd_times_qd=0;

F_q1s=zeros(6,1);
F_q2s=zeros(6,1);
F_q3s=zeros(6,1);
F_q4s=zeros(6,1);

F_1t=zeros(3,1);
F_2t=zeros(3,1);
F_3t=zeros(3,1);
F_4t=zeros(3,1);

if d_1<rho_0 %&& d_1_dot<0
    F_1t=nu*(p1-pc)/norm(p1-pc)*(1/d_1-1/rho_0)/d_1^2;
    F_q1s=J_p1'*F_1t;
    F_1=J*F_q1s+Jd*qd*turn_on_Jacd_times_qd;
end
if d_2<rho_0 %&& d_2_dot<0
    F_2t=nu*(p2-pc)/norm(p2-pc)*(1/d_2-1/rho_0)/d_2^2;
    F_q2s=J_p2'*F_2t;
    F_2=J*F_q2s+Jd*qd*turn_on_Jacd_times_qd;
end
if d_3<rho_0 %&& d_3_dot<0
    F_3t=nu*(p3-pc)/norm(p3-pc)*(1/d_3-1/rho_0)/d_3^2;
    F_q3s=J_p3'*F_3t;
    F_3=J*F_q3s+Jd*qd*turn_on_Jacd_times_qd;
end
if d_4<rho_0 %&& d_4_dot<0
    F_4t=nu*(p4-pc)/norm(p4-pc)*(1/d_4-1/rho_0)/d_4^2;
    F_q4s=J_p4'*F_4t;
    F_4=J*F_q4s+Jd*qd*turn_on_Jacd_times_qd;
end


%find shorest distence to the floor for the rest of the robot

d_floor1=o2(3);
d_floor2=o3(3);
d_floor3=o4(3);

J_o1=[cross(z0,o2-o0),cross(z1,o2-o1),zeros(3,4)];
J_o2=[cross(z0,o3-o0),cross(z1,o3-o1),cross(z2,o3-o2),zeros(3,3)];
J_o3=[cross(z0,o4-o0),cross(z1,o4-o1),cross(z2,o4-o2),zeros(3,3)];

J_w1=[z0,z1,zeros(3,4)];
J_w2=[z0,z1,z2,zeros(3,3)];
J_w3=[z0,z1,z2,z4,zeros(3,2)];


Fx_back1=zeros(6,1);
Fx_back2=zeros(6,1);
Fx_back3=zeros(6,1);

F_q1=zeros(6,1);
F_q2=zeros(6,1);
F_q3=zeros(6,1);

Fx_1=zeros(3,1);
Fx_2=zeros(3,1);
Fx_3=zeros(3,1);

v_o2=J_o2*qd;
v_o3=J_o3*qd;
v_o4=J*qd;

if d_floor1<rho_0 %&& v_o2(3)<0
    Fx_1=[0;0;1]*1/((o2(3)))^2*(1/abs(((o2(3))))-1/rho_0);
    F_q1=J_o1'*Fx_1;
    Fx_back1=J*F_q1+Jd*qd*turn_on_Jacd_times_qd;

end
if d_floor2<rho_0 %&& v_o3(3)<0
    Fx_2=[0;0;1]*1/((o3(3)))^2*(1/abs(((o3(3))))-1/rho_0);
    F_q2=J_o2'*Fx_2;
    Fx_back2=J*F_q2+Jd*qd*turn_on_Jacd_times_qd;

end
if d_floor3<rho_0 %&& v_o4(3)<0
    Fx_3=[0;0;1]*1/((o4(3)))^2*(1/abs(((o4(3))))-1/rho_0);
    F_q3=J_o3'*Fx_3;
    Fx_back1=J*F_q3+Jd*qd*turn_on_Jacd_times_qd;
end

% 
% if o2(3)<0 || o3(3)<0 || o4(3)<0 || o5(3)<0 || o6(3)<0 
%     disp('fail!!!!')
%     o1,o2,o3,o4,o5,o6
% end


% u_repulsive=u_repulsive+Fx_back1(1:3)+Fx_back2(1:3)+Fx_back3(1:3);
% u_repulsive=u_repulsive+F_1(1:3)+F_2(1:3)+F_3(1:3)+F_4(1:3);
% Ut=u_repulsive;

%The repulsive forces in WORKSPACE is given by:

% F_ee, J
% F_1t, J_p1
% F_2t, J_p2
% F_3t, J_p3
% F_4t, J_p4
% Fx_1, J_o1
% Fx_2, J_o2
% Fx_3, J_o3
% clc
% 
% F_1
% F_2
% F_3
% F_4
% F_x1
% F_x2
% F_x3
% disp('---')
J_o1=[J_o1;zeros(3,6)];
J_o2=[J_o2;zeros(3,6)];
J_o3=[J_o3;zeros(3,6)];

J_p1=[J_p1;zeros(3,6)];
J_p2=[J_p2;zeros(3,6)];
J_p3=[J_p3;zeros(3,6)];
J_p4=[J_p4;zeros(3,6)];
% 

% 
% Ja=[eye(3) zeros(3);zeros(3) inv(Rq*B)]*J;
% Jai=Ja'/(Ja*Ja'+0.001*eye(6));
% 
% p1=pinv(J);
% p2=pinv(J_p1);
% p3=pinv(J_p2);
% p4=pinv(J_p3);
% p5=pinv(J_p4);
% p6=pinv(J_o1);
% p7=pinv(J_o2);
% p8=pinv(J_o3);
% 
% 
% u=Ji*([u2_pos;u2_o]-Jd*qd)+...
%     Jai*(...
%     p1'*Ja'*[F_ee;0;0;0]+...
%     p2'*J_p1'*[F_1t;0;0;0]+...
%     p3'*J_p2'*[F_2t;0;0;0]+...
%     p4'*J_p3'*[F_3t;0;0;0]+...
%     p5'*J_p4'*[F_4t;0;0;0]+...
%     p6'*J_o1'*[Fx_1;0;0;0]+...
%     p7'*J_o2'*[Fx_2;0;0;0]+...
%     p8'*J_o3'*[Fx_3;0;0;0]...
%     );

M=massmatrix(q);
% F_ee, J
% F_1t, J_p1
% F_2t, J_p2
% F_3t, J_p3
% F_4t, J_p4
% Fx_1, J_o1
% Fx_2, J_o2
% Fx_3, J_o3


F_1t=[F_1t;0;0;0];
F_2t=[F_2t;0;0;0]; 
F_3t=[F_3t;0;0;0];
F_4t=[F_4t;0;0;0];
Fx_1=[Fx_1;0;0;0];
Fx_2=[Fx_2;0;0;0];
Fx_3=[Fx_3;0;0;0];

Select=[eye(3) zeros(3);zeros(3) zeros(3)];


u2_pos=-Kp*(x-x_ref)-Kd*(v-v_ref)+0*a_ref;
u2_o=0*wd_ref-(S(w)*Rq*B+Rq*dB_dt)*rpy_d + Rq*B*(Kd*rpy_d+Kp*[phi;theta;psi]);


F_rep=+Ji'*(J_o1'*Fx_1+J_o2'*Fx_2+J_o3'*Fx_3+J_p1'*F_1t+J_p2'*F_2t+J_p3'*F_3t+J_p4'*F_4t)+[u_repulsive;0;0;0];
F_rep(4:6)=[0;0;0];


u=Ji*([u2_pos;u2_o]-Jd*qd);

%u=Ji*([u2_pos;u2_o]-Jd*qd);%;+inv(M)*(J_p1'*F_1t+J_p2'*F_2t+J_p3'*F_3t+J_p4'*F_4t+J_o1'*Fx_1+J_o2'*Fx_2+J_o3'*Fx_3);
%u=Ji*([u2_pos;u2_o]-Jd*qd)
%[Fx_1 Fx_2 Fx_3]

state_dot=[qd;
           u];

       
       