clc
clear all
close all

syms q1 q2 real
syms x y real
 
%make a box
sat=@(x)((1/2*sign(x)+1/2)*x-(1/2*sign(x-1)+1/2)*(x-1));
dsat=@(x)(1/2*(sign(x)-sign(x-1)));
nu1=@(x)(1/2*(x-abs(x)));
nu2=@(x)(1/2*(x+abs(x)));

onoff=@(k,kdot)(1-(heaviside(-k)*heaviside(-kdot)+(heaviside(k-1)*heaviside(kdot))));
%onoff=@(k,kdot)(1-((-sign(k)+1)/2*(-sign(kdot)+1)/2+(sign(k-1)+1)/2*(sign(kdot)+1)/2));
%onoff=@(k,kdot)(1 - heaviside(k - 1)*heaviside(kdot))

%ezsurf((1-1/4*((sign(x)-1)*(sign(y)-1)+(sign(x-1)+1)*(sign(y)+1)))*x,[-1 2
%-2 2])

g1=abs(x+1/3)-1/3;
g2=abs(y-1)-1/3;


w=.4;
he=.2;
theta=pi/6;
xp=-.6;
yp=.5;

g1=abs(cos(theta)*(x-xp)-sin(theta)*(y-yp))^2-w^2;
g2=abs(sin(theta)*(x-xp)+cos(theta)*(y-yp))^2-he^2;

%Z=beta1+beta2+abs(beta1-beta2);

Z=g1+g2+abs(g1-g2);
%Z=g1+abs(g1)+g2+abs(g2)

Z=(x+1/3)^10+(y-1)^10-1/3^10;

%ezplot(Z)
zf=matlabFunction(Z);
J2=matlabFunction(jacobian(Z^2,[x,y])');
J=matlabFunction(jacobian(Z,[x,y])');

%construct the gradient manually
% phi1=1+sign(g1-g2);
% PHI=[phi1;2-phi1];
% Jt=jacobian([g1,g2],[x,y]);
% Grad=Jt'*PHI;
 
%rectangle('position',[-2/3 1-1/3 2/3 2/3])
hold on 

l1=1;l2=1;
t=.5;

h=0.01;%the integration step length for the distance estimation
h2=0.01;%the integration step length for the robot

%initial conditions
q1=sin(0);
q2=sin(0);

 

o1 =[l1*cos(q1);
     l1*sin(q1)];

o2=[l2*cos(q1 + q2) + l1*cos(q1);
    l2*sin(q1 + q2) + l1*sin(q1)];

psi1=[-0.25;1];%starting position
psi2=[-0.25;1];%starting position

gamma1=o1;
gamma2=o2-o1;

gain=10;

k1=1/2;
k2=1/2;

d1=0;

k1o=k1;
k2o=k2;
psi1o=psi1;
psi2o=psi2;

hand1=plot([k1*gamma1(1) psi1(1)],[k1*gamma1(2) psi1(2)],'r-');
hand2=plot([o1(1)+k2*gamma2(1) psi2(1)],[o1(2)+k2*gamma2(2) psi2(2)],'r-');

handk1=plot([k1*gamma1(1) psi1(1)],[k1*gamma1(2) psi1(2)],'g-');
handk2=plot([o1(1)+k2*gamma2(1) psi2(1)],[o1(2)+k2*gamma2(2) psi2(2)],'g-');

jointpos=zeros(3,2);
jointpos(2,:)=o1';
jointpos(3,:)=o2';

hand3=plot(jointpos(:,1),jointpos(:,2),'-o','LineWidth',1);

K_psi=1;

syms xt yt real

g1=abs(cos(theta)*(xt-xp)-sin(theta)*(yt-yp))^2-w^2;
g2=abs(sin(theta)*(xt-xp)+cos(theta)*(yt-yp))^2-he^2;

hanf=ezplot(Z,[-2 2 -2 2]); 

Ds=[];
DDs=[];
Ds2=[];
DDs2=[];

for jk=1:10000
    t=t+h2;
%    t=0.6800;
    
%    theta=t;
    q1=sin(t)+.2;
    q2=sin(5*t)+.1;

    o1 =[l1*cos(q1);
         l1*sin(q1)];

    o2=[l2*cos(q1 + q2) + l1*cos(q1);
        l2*sin(q1 + q2) + l1*sin(q1)];

    o1d=[
     -sin(sin(t) + 1/5)*cos(t)
     cos(sin(t) + 1/5)*cos(t)];
 
 
    o2d =[ 
     - sin(sin(5*t) + sin(t) + 3/5)*(5*cos(5*t) + cos(t)) - sin(sin(t) + 1/5)*cos(t)
    cos(sin(5*t) + sin(t) + 3/5)*(5*cos(5*t) + cos(t)) + cos(sin(t) + 1/5)*cos(t)];

    
    gamma1=o1;
    gamma2=o2-o1;
    
    gamma1d=o1d;
    gamma2d=o2d-o1d;
    
    
%     
%     g1=abs(cos(theta)*(xt-xp)-sin(theta)*(yt-yp))^2-w^2;
%     g2=abs(sin(theta)*(xt-xp)+cos(theta)*(yt-yp))^2-he^2;
% 
%     %Z=beta1+beta2+abs(beta1-beta2);
%      
%     set(hanf,'Visible','off')
%     hanf=ezplot(g1+g2+abs(g1-g2),[-2 2 -2 2]); 
%     
    
    
    for i=1:6
        
        scale=0.000000001;

        %calculate the optimal k1 k2
        k1=sat(o1'*psi1);
        k2=sat((o1-o2)'*(o1-psi2));
        
        Z_psi1=zf(psi1(1),psi1(2));
        J_psi1=J(psi1(1),psi1(2));
        J2_psi1=J2(psi1(1),psi1(2));

        Z_psi2=zf(psi2(1),psi2(2));
        J_psi2=J(psi2(1),psi2(2));
        J2_psi2=J2(psi2(1),psi2(2));

        F1=(k1*gamma1-psi1);
        %F1n=(J2(psi1(1),psi1(2)))/(norm((J2(psi1(1),psi1(2)))));
        F1n=J_psi1/(norm(J_psi1)+scale);
        F1c=F1-(F1'*F1n)*F1n;
        F1c=F1c/norm(F1c);
        
        psi1_dot=F1c-K_psi*J2_psi1/(norm(J2_psi1)+scale);

 %       k1_dot=-(gain*((k1*gamma1-psi1)'*gamma1/norm(gamma1))*1/norm(gamma1));
 %       k1_dot=onoff(k1,k1_dot)*k1_dot;

        psi1=psi1+h*psi1_dot;
%        k1=k1+h*k1_dot;

        

        F2=(k2*gamma2+o1-psi2);
%        F2n=(J2(psi2(1),psi2(2)))/(norm((J2(psi2(1),psi2(2)))));       
        F2n=J_psi2/(norm(J_psi2)+scale);

        F2c=F2-(F2'*F2n)*F2n;
        F2c=F2c/norm(F2c);
        
        
%        psi2_dot=+F2c-K_psi*(J(psi2(1),psi2(2)))/norm((J(psi2(1),psi2(2))));

        psi2_dot=+F2c-K_psi*J2_psi2/(norm(J2_psi2)+scale);
        
       % test=dot(F2c,K_psi*J2_psi2/(norm(J2_psi2)+scale))
        
        %k2_dot=-gain*((k2*gamma2+o1-psi2)'*gamma2/norm(gamma2))*1/norm(gamma2);
        %k2_dot=onoff(k2,k2_dot)*k2_dot;

        psi2=psi2+h*psi2_dot;
        %k2=k2+h*k2_dot;


        
%         k1=sat(k1);
%         k2=sat(k2); 
%     
    end
    
    %estimeate time to collision for the first joint

%     alpha=gamma1*k1;
% 

%    d1=(gamma1*k1-psi1)'*(gamma1*k1-psi1);
  %  d_dot1=2*((gamma1*k1-psi1)'*(k1_dot*o1+k1*o1d) +(psi1-gamma1*k1)'*psi1_dot);
  %  d_dot12=2*((gamma1*k1-psi1)'*(k1*o1d));

%     d2=(o1+gamma2*k2-psi2)'*(o1+gamma2*k2-psi2);
%     d_dot2=2*((o1+gamma2*k2-psi2)'*(k2_dot*o1+k1*o1d) +(psi1-gamma1*k1)'*psi1_dot);
%     d_dot22=2*((o1+gamma2*k2-psi2)'*(k1*o1d));

    
    
%    Ds=[Ds d1];
%    DDs=[DDs d_dot1];
%    DDs2=[DDs2 d_dot12];

    
    axis([-2 2 -2 2])
    axis square
    
    jointpos=zeros(3,2);
    jointpos(2,:)=o1';
    jointpos(3,:)=o2';
    
   %plot([psi1(1) psi1(1)+F1c(1)],[psi1(2) psi1(2)+F1c(2)],'-')
    set(hand1,'Xdata',[k1*gamma1(1) psi1(1)],'Ydata',[k1*gamma1(2) psi1(2)]);
    set(hand2,'Xdata',[o1(1)+k2*gamma2(1) psi2(1)],'Ydata',[o1(2)+k2*gamma2(2) psi2(2)]);
    set(hand3,'Xdata',jointpos(:,1),'Ydata',jointpos(:,2));

    
    
        for i=1:6
         scale=0.00000001;
       % scale=0.00001;
        
        Z_psi1=zf(psi1o(1),psi1o(2));
        J_psi1=J(psi1o(1),psi1o(2));
        J2_psi1=J2(psi1o(1),psi1o(2));

        Z_psi2=zf(psi2o(1),psi2o(2));
        J_psi2=J(psi2o(1),psi2o(2));
        J2_psi2=J2(psi2o(1),psi2o(2));

        F1=(k1o*gamma1-psi1o);
        %F1n=(J2(psi1o(1),psi1o(2)))/(norm((J2(psi1o(1),psi1o(2)))));
        F1n=J_psi1/(norm(J_psi1)+scale);
        F1c=F1-(F1'*F1n)*F1n;
        F1c=F1c/norm(F1c);
        
        psi1_dot=F1c-K_psi*J2_psi1/(norm(J2_psi1)+scale);

        k1_dot=-(gain*((k1o*gamma1-psi1o)'*gamma1/norm(gamma1))*1/norm(gamma1));
        k1_dot=onoff(k1o,k1_dot)*k1_dot;

        psi1o=psi1o+h*psi1_dot;
        k1o=k1o+h*k1_dot;


        F2=(k2o*gamma2+o1-psi2o);
%        F2n=(J2(psi2o(1),psi2o(2)))/(norm((J2(psi2o(1),psi2o(2)))));       
        F2n=J_psi2/(norm(J_psi2)+scale);

        F2c=F2-(F2'*F2n)*F2n;
        F2c=F2c/norm(F2c);
        
        
%        psi2_dot=+F2c-K_psi*(J(psi2o(1),psi2o(2)))/norm((J(psi2o(1),psi2o(2))));

        psi2_dot=+F2c-K_psi*J2_psi2/(norm(J2_psi2)+scale);
        
       % test=dot(F2c,K_psi*J2_psi2/(norm(J2_psi2)+scale))
        
        k2_dot=-gain*((k2o*gamma2+o1-psi2o)'*gamma2/norm(gamma2))*1/norm(gamma2);
        k2_dot=onoff(k2o,k2_dot)*k2_dot;

        psi2o=psi2o+h*psi2_dot;
        k2o=k2o+h*k2_dot;

%         k1o=sat(k1o);
%         k2o=sat(k2o); 
        
    end

    set(handk1,'Xdata',[k1o*gamma1(1) psi1o(1)],'Ydata',[k1o*gamma1(2) psi1o(2)]);
    set(handk2,'Xdata',[o1(1)+k2o*gamma2(1) psi2o(1)],'Ydata',[o1(2)+k2o*gamma2(2) psi2o(2)]);
    
    
    
drawnow
end    
break
%%
syms o1x o1y o2x o2y real
syms k1 k2 real
syms psi1x psi1y psi2x psi2y real
syms gain positive

o1=[o1x;o1y];
o2=[o2x;o2y];
psi1=[psi1x;psi1y];
psi2=[psi2x;psi2y];

gamma1=o1;
gamma2=o2-o1;

norm=@(inp)(sqrt(inp(1)^2+inp(2)^2));

syms x y real
syms Kp1 Kp2 positive
g1=abs(x+1/3)-1/3;
g2=abs(y-1)-1/3;
Z=g1+g2+abs(g1-g2);

% phi1=1+sign(g1-g2);
% PHI=[phi1;2-phi1];
% Jt=jacobian([g1,g2],[x,y]);
%   
% dZ=Jt'*PHI;
% dZ2=2*Z*Jt'*PHI;

dZ=simple(simple([diff(Z,x);diff(Z,y)]));
dZ2=simple(simple([diff(Z^2,x);diff(Z^2,y)]));

Jpsi1=subs(dZ,[x,y],psi1);
Jpsi2=subs(dZ,[x,y],psi2);

J2psi1=subs(dZ2,[x,y],psi1);
J2psi2=subs(dZ2,[x,y],psi2);

F1=(k1*gamma1-psi1);
F1n=Jpsi1/4;       

F1c=F1-(F1'*F1n)*F1n;
F1c=F1c/norm(F1c);

F2=(k2*gamma2+o1-psi2);

F2n=Jpsi2/4;    
F2c=F2-(F2'*F2n)*F2n;
F2c=F2c/norm(F2c);

psi1_dot=+F1c-Kp1*(J2psi1);
psi1=psi1+h*psi1_dot;

k1_dot=Kp2*((k1*gamma1-psi1)'*gamma1/norm(gamma1))*1/norm(gamma1);
k1=k1-h*k1_dot;
%k1=sat(k1);

psi2_dot=F2c-Kp1*J2psi2;
k2_dot=Kp2*((k2*gamma2+o1-psi2)'*gamma2/norm(gamma2))*1/norm(gamma2);

psi2=psi2+h*psi2_dot;
k2=k2-h*k2_dot;
%k2=sat(k2);

break
%%
pos=[2,2];
xp=pos(1);
yp=pos(2);

w=2;
h=1;
close
theta=pi/4;

beta1=abs(cos(theta)*(x-xp)-sin(theta)*(y-yp))^2-w^2;
beta2=abs(sin(theta)*(x-xp)+cos(theta)*(y-yp))^2-h^2;

Z=beta1+beta2+abs(beta1-beta2);
hold on
ezplot(Z1,[-5 5 -5 5])

hold on

beta1=abs(cos(theta)*x-sin(theta)*y)-w;
beta2=abs(sin(theta)*x+cos(theta)*y)-h;

Z2=beta1+beta2+abs(beta1-beta2);
hold on
ezplot(Z2,[-5 5 -5 5])


break
%%
pos=[1,1];
w=2;
h=1;

syms w h theta  positive
syms x y xp yp real




    