function G = gravity_vector(q)

global a2 a3 d4 g m2 m3 m4 m5 m6 r2 r3 r4 r5 r6 g

q1=q(1);
q2=q(2);
q3=q(3);
q4=q(4);
q5=q(5);
q6=q(6);

t2 = q2 + q3;
t3 = cos(t2);
t4 = d4.*t3;
t5 = sin(t2);
t6 = cos(q2);
t7 = a2.*t6;
t8 = cos(q5);
t9 = t3.*t8;
t10 = cos(q4);
t11 = sin(q5);
t13 = t10.*t11.*t5;
t12 = t9 - t13;
t14 = r5.*t12;
t15 = r6.*t12;
t16 = a3.*t5;
t17 = m5.*r5;
t18 = m6.*r6;
t19 = t17 + t18;

G = [0;
    - g.*m5.*(t14 + t4 + t7 - a3.*t5) - g.*m6.*(t15 + t4 + t7 - a3.*t5) - g.*m3.*(t4 + t7 - a3.*t5 - r3.*t3) - g.*m4.*(t4 + t7 - a3.*t5 - r4.*t3) - g.*m2.*r2.*t6;
    g.*m3.*(t16 - t4 + r3.*t3) + g.*m4.*(t16 - t4 + r4.*t3) - g.*m5.*(t14 + t4 - a3.*t5) - g.*m6.*(t15 + t4 - a3.*t5);
    g.*t11.*t19.*t3.*sin(q4);
    g.*t19.*(t11.*t5 - t10.*t3.*t8);
    0];
